<?php

class manufactoryProductSkusGenerate
{
    protected $features = array();
    protected $features_variants = array();

    public function __construct($features)
    {
        if (is_array($features)) {
            $this->features = $features;
            ksort($this->features);
        }
    }

    public function generate()
    {
        $data = array();
        $offers = array();
        $feature_groups = manufactoryFeaturesPool::getInstance()->getFeatureGroups();
        foreach ($this->features as $feature_id => $values) {
            $feature = manufactoryFeaturesPool::getInstance()->get($feature_id);
            foreach ($feature_groups as $gv) {
                $feature_values = $feature->getValues($gv['id']);
                foreach ($feature_values as $value_id => $value_data) {
                    if (isset($values[$value_id])) {
                        $data[$gv['id']][$feature_id][$value_id] = $value_id;
                    }
                }
            }
        }
        foreach ($data as $cluster) {
            $gen = new manufactoryFeaturesSkusGenerate();
            $offers = $offers + $gen->generate($cluster);
        }

        return $offers;
    }
}






































/*
$features = array(
    '10' => array(
        110,120,130
    ),
    '20' => array(
        210,220,230
    ),
    '30' => array(
        310,320,330
    ),
    '40' => array(
        410,420,430
    ),
);

// нужна переменна features_values
$features = array(
    '10' =>  110,
    '20' =>210
    //.....
);
// нужно передавать features в рекурсию но без текущей характеристики
/// unset($feature[$k])
// записывать еще строчное значение temp
// передавать левел
$features = array(
    '10' =>  110,
    '20' =>210
    //.....
);
$values = array(
    110 =>[
        210 =>[
            310 =>[
                410=> array(110,210,310,410),
                420=> array(110,210,310,420),
                430=> array(110,210,310,430),
            ],
            320 =>[
                410=> array(110,210,320,410),
                420=> array(110,210,320,420),
                430=> array(110,210,320,430),
            ],
            330 =>[
                410=> array(110,210,330,410),
                420=> array(110,210,330,420),
                430=> array(110,210,330,430),
            ],
        ],
        220 =>[
            310 =>[
                410=> array(110,220,310,410),
                420=> array(110,220,310,420),
                430=> array(110,220,310,430),
            ],
            320 =>[
                410=> array(110,220,320,410),
                420=> array(110,220,320,420),
                430=> array(110,220,320,430),
            ],
            330 =>[
                410=> array(110,220,330,410),
                420=> array(110,220,330,420),
                430=> array(110,220,330,430),
            ],
        ],
        230 =>[
            310 =>[
                410=> array(110,230,310,410),
                420=> array(110,230,310,420),
                430=> array(110,230,310,430),
            ],
            320 =>[
                410=> array(110,230,320,410),
                420=> array(110,230,320,420),
                430=> array(110,230,320,430),
            ],
            330 =>[
                410=> array(110,230,330,410),
                420=> array(110,230,330,420),
                430=> array(110,230,330,430),
            ],
        ],
        ],
    120  =>[
        210 =>[
            310 =>[
                410=> array(120,210,310,410),
                420=> array(120,210,310,420),
                430=> array(120,210,310,430),
            ],
            320 =>[
                410=> array(120,210,320,410),
                420=> array(120,210,320,420),
                430=> array(120,210,320,430),
            ],
            330 =>[
                410=> array(120,210,330,410),
                420=> array(120,210,330,420),
                430=> array(120,210,330,430),
            ],
        ],
        220 =>[
            310 =>[
                410=> array(120,220,310,410),
                420=> array(120,220,310,420),
                430=> array(120,220,310,430),
            ],
            320 =>[
                410=> array(120,220,320,410),
                420=> array(120,220,320,420),
                430=> array(120,220,320,430),
            ],
            330 =>[
                410=> array(120,220,330,410),
                420=> array(120,220,330,420),
                430=> array(120,220,330,430),
            ],
        ],
        230 =>[
            310 =>[
                410=> array(120,230,310,410),
                420=> array(120,230,310,420),
                430=> array(120,230,310,430),
            ],
            320 =>[
                410=> array(120,230,320,410),
                420=> array(120,230,320,420),
                430=> array(120,230,320,430),
            ],
            330 =>[
                410=> array(120,230,330,410),
                420=> array(120,230,330,420),
                430=> array(120,230,330,430),
            ],
        ],
    ],
    130 =>[
        210 =>[
            310 =>[
                410=> array(130,210,310,410),
                420=> array(130,210,310,420),
                430=> array(130,210,310,430),
            ],
            320 =>[
                410=> array(130,210,320,410),
                420=> array(130,210,320,420),
                430=> array(130,210,320,430),
            ],
            330 =>[
                410=> array(130,210,330,410),
                420=> array(130,210,330,420),
                430=> array(130,210,330,430),
            ],
        ],
        220 =>[
            310 =>[
                410=> array(130,220,310,410),
                420=> array(130,220,310,420),
                430=> array(130,220,310,430),
            ],
            320 =>[
                410=> array(130,220,320,410),
                420=> array(130,220,320,420),
                430=> array(130,220,320,430),
            ],
            330 =>[
                410=> array(130,220,330,410),
                420=> array(130,220,330,420),
                430=> array(130,220,330,430),
            ],
        ],
        230 =>[
            310 =>[
                410=> array(130,230,310,410),
                420=> array(130,230,310,420),
                430=> array(130,230,310,430),
            ],
            320 =>[
                410=> array(130,230,320,410),
                420=> array(130,230,320,420),
                430=> array(130,230,320,430),
            ],
            330 =>[
                410=> array(130,230,330,410),
                420=> array(130,230,330,420),
                430=> array(130,230,330,430),
            ],
        ],
    ],
//// Тут нет смысла перебирать, уже есть со всеми вариантами
    210,
    220,
    230,

    310,
    320,
    330,

    410,
    420,
    430


);*/
